"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ViewToolBar;
var _react = _interopRequireWildcard(require("react"));
var _viewToolBarModule = _interopRequireDefault(require("./styles/viewToolBar.module.css"));
var _FocusAuto = _interopRequireDefault(require("./imgs/Focus-Auto.svg"));
var _FocusAllAuto = _interopRequireDefault(require("./imgs/FocusAll-Auto.svg"));
var _showSelected = _interopRequireDefault(require("./imgs/showSelected.svg"));
var _showAll = _interopRequireDefault(require("./imgs/showAll.svg"));
var _visible = _interopRequireDefault(require("./imgs/visible.svg"));
var _invisible = _interopRequireDefault(require("./imgs/invisible.svg"));
var _wireframe = _interopRequireDefault(require("./imgs/wireframe.svg"));
var _measure = _interopRequireDefault(require("./imgs/measure.svg"));
var _opacity = _interopRequireDefault(require("./imgs/opacity.svg"));
var _inopacity = _interopRequireDefault(require("./imgs/inopacity.svg"));
var _asis = _interopRequireDefault(require("./imgs/asis.svg"));
var _help = _interopRequireDefault(require("./imgs/help.svg"));
var _tuoDocument = require("tuo-document");
var _reactMarkdown = _interopRequireDefault(require("react-markdown"));
var _remarkGfm = _interopRequireDefault(require("remark-gfm"));
var _manual = require("./manual");
var _reactHotKeys = _interopRequireDefault(require("react-hot-keys"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var operations = [{
  isSpacer: true
}, {
  isDivider: true
}, {
  img: _FocusAllAuto["default"],
  title: '聚焦全部对象',
  action: 'focusAll'
}, {
  img: _FocusAuto["default"],
  title: '聚焦选中对象',
  action: 'focusTarget'
}, {
  img: _showAll["default"],
  title: '显示所有对象',
  action: 'showAll'
}, {
  img: _visible["default"],
  title: '显示被选中对象',
  action: 'showSelected'
}, {
  img: _invisible["default"],
  title: '隐藏选中对象',
  action: 'hideSelected'
}, {
  img: _showSelected["default"],
  title: '仅显示选中对象',
  action: 'visibleOnly'
}, {
  isDivider: true
}, {
  img: _asis["default"],
  title: '实体渲染',
  action: 'asis'
}, {
  img: _wireframe["default"],
  title: '线框渲染',
  action: 'wireframe'
}, {
  img: _opacity["default"],
  title: '设选中对象为透明',
  action: 'opacity'
}, {
  img: _inopacity["default"],
  title: '设选中对象为非透明',
  action: 'inOpacity'
}, {
  isDivider: true
}, {
  img: _measure["default"],
  title: '测量模式',
  action: 'measure'
}, {
  isDivider: true
}, {
  img: _help["default"],
  title: '帮助',
  action: 'help'
}];
function ViewToolBar(_ref) {
  var doc = _ref.doc,
    hasFocus = _ref.hasFocus;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    measureDialog = _useState2[0],
    setMeasureDialog = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = _slicedToArray(_useState3, 2),
    manualDialog = _useState4[0],
    setManualDialog = _useState4[1];
  if (!doc) return null;
  var getSelectedId = function getSelectedId() {
    var raycast = doc.mainStore.getState().raycast;
    if (raycast.selected.length == 0) return undefined;
    var firstSelected = raycast.selected[0];
    if (typeof firstSelected === 'string') return firstSelected;
    return _tuoDocument.utils.getNodeKey(firstSelected.object);
  };
  var getSelectedIds = function getSelectedIds() {
    var raycast = doc.mainStore.getState().raycast;
    return raycast.selected.map(function (selected) {
      return typeof selected === 'string' ? selected : _tuoDocument.utils.getNodeKey(selected.object);
    });
  };
  var getAllNodesVisiblePayload = function getAllNodesVisiblePayload() {
    var nodes = doc.mainStore.getState().nodes.present;
    return nodes.allIds.reduce(function (previous, currentValue) {
      previous[currentValue] = true;
      return previous;
    }, {});
  };
  var checkIsGroupNode = function checkIsGroupNode(id) {
    var nodes = doc.mainStore.getState().nodes.present;
    return nodes.byId[id].type === 'group';
  };
  var getAllNodesVisibleExceptPayload = function getAllNodesVisibleExceptPayload() {
    var nodes = doc.mainStore.getState().nodes.present;
    var selectedIds = getSelectedIds().map(function (id) {
      return _tuoDocument.utils.getSelectedObjectId(doc, id);
    });
    var tartgetIds = nodes.allIds.reduce(function (previous, currentValue) {
      if (!nodes.byId[currentValue].options) return previous;
      if (selectedIds.findIndex(function (v) {
        return v === currentValue;
      }) > -1) {
        previous[currentValue] = true;
      } else if (nodes.byId[currentValue].options.type === 'Part' && nodes.byId[currentValue].options.tuzhiAdded) {
        previous[currentValue] = false;
      } else if (checkIsGroupNode(currentValue) || nodes.byId[currentValue].options.type !== 'Object') {
        previous[currentValue] = true;
      } else previous[currentValue] = false;
      return previous;
    }, {});

    // console.log('tartgetIds:', tartgetIds)
    return tartgetIds;
  };
  var getAllSelectedVisiblePayload = function getAllSelectedVisiblePayload(value) {
    return getSelectedIds().map(function (id) {
      return _tuoDocument.utils.getSelectedObjectId(doc, id);
    }).reduce(function (previous, currentValue) {
      previous[currentValue] = value;
      return previous;
    }, {});
  };
  var getAllSelectedRenderTypePayload = function getAllSelectedRenderTypePayload(value) {
    return getSelectedIds().map(function (id) {
      return _tuoDocument.utils.getSelectedObjectId(doc, id);
    }).reduce(function (previous, currentValue) {
      previous[currentValue] = value;
      return previous;
    }, {});
  };
  var onClick = function onClick(action) {
    switch (action) {
      case 'focusAll':
        doc.viewDocument.fitScene(true, true);
        break;
      case 'showAll':
        //this.props.setNodesVisible(this.getAllNodesVisiblePayload())
        doc.dispatch({
          type: _tuoDocument.types.SET_NODES_VISIBLE,
          payload: getAllNodesVisiblePayload()
        });
        break;
      case 'focusTarget':
        //this.props.fitSelected(this.getSelectedId())
        doc.viewDocument.fitObject(getSelectedId());
        break;
      case 'visibleOnly':
        //this.props.setNodesVisible(getAllNodesVisibleExceptPayload())
        doc.dispatch({
          type: _tuoDocument.types.SET_NODES_VISIBLE,
          payload: getAllNodesVisibleExceptPayload()
        });
        break;
      case 'showSelected':
        //this.props.setNodesVisible(this.getAllSelectedVisiblePayload(true))
        doc.dispatch({
          type: _tuoDocument.types.SET_NODES_VISIBLE,
          payload: getAllSelectedVisiblePayload(true)
        });
        break;
      case 'hideSelected':
        //this.props.setNodesVisible(this.getAllSelectedVisiblePayload(false))
        doc.dispatch({
          type: _tuoDocument.types.SET_NODES_VISIBLE,
          payload: getAllSelectedVisiblePayload(false)
        });
        break;
      case 'asis':
        //this.props.setNodesRenderType(this.getAllSelectedRenderTypePayload('asis'))
        doc.dispatch({
          type: _tuoDocument.types.SET_NODES_RENDERTYPE,
          payload: getAllSelectedRenderTypePayload('asis')
        });
        break;
      case 'wireframe':
        //this.props.setNodesRenderType(this.getAllSelectedRenderTypePayload('wireframe'))
        doc.dispatch({
          type: _tuoDocument.types.SET_NODES_RENDERTYPE,
          payload: getAllSelectedRenderTypePayload('wireframe')
        });
        break;
      case 'opacity':
        doc.dispatch({
          type: _tuoDocument.types.SET_NODES_MATERIAL,
          payload: getSelectedIds().map(function (id) {
            return _tuoDocument.utils.getSelectedObjectId(doc, id);
          }).reduce(function (acc, id) {
            acc[id] = {
              face: {
                transparent: true,
                opacity: 0.5
              }
            };
            return acc;
          }, {})
        });
        break;
      case 'inOpacity':
        doc.dispatch({
          type: _tuoDocument.types.SET_NODES_MATERIAL,
          payload: getSelectedIds().map(function (id) {
            return _tuoDocument.utils.getSelectedObjectId(doc, id);
          }).reduce(function (acc, id) {
            acc[id] = {
              face: {
                transparent: false,
                opacity: 1
              }
            };
            return acc;
          }, {})
        });
        break;
      case 'measure':
        setMeasureDialog(!measureDialog);
        break;
      case 'help':
        setManualDialog(!manualDialog);
        break;
      /*
      case 'measure':
      onMenuClick()
      break;
      case 'opacity':
      setDialog(actionType);
      break;*/
    }
  };

  var onKeyDown = function onKeyDown(keyName, e, handle) {
    switch (keyName) {
      case 'h':
        onClick('help');
        break;
      case 'shift+f':
        onClick('focusAll');
        break;
      case 'f':
        onClick('focusTarget');
        break;
      case 'shift+v':
        onClick('showAll');
        break;
      case 'v':
        onClick('showSelected');
        break;
      case 'c':
        onClick('hideSelected');
        break;
      case 'z':
        onClick('visibleOnly');
        break;
      case 'a':
        onClick('asis');
        break;
      case 'w':
        onClick('wireframe');
        break;
      case 't':
        onClick('opacity');
        break;
      case 'shift+t':
        onClick('inOpacity');
        break;
      case 'm':
        onClick('measure');
        break;
    }
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _viewToolBarModule["default"].container
  }, operations.map(function (operation, index) {
    if (operation.isSpacer) return /*#__PURE__*/_react["default"].createElement("div", {
      key: index,
      className: _viewToolBarModule["default"].spacer
    });
    if (operation.isDivider) return /*#__PURE__*/_react["default"].createElement("div", {
      key: index,
      className: _viewToolBarModule["default"].divider
    });
    return /*#__PURE__*/_react["default"].createElement(ToolBarIcon, {
      img: operation.img,
      title: operation.title,
      action: operation.action,
      onClick: onClick,
      key: index
    });
  }), measureDialog ? /*#__PURE__*/_react["default"].createElement(MeasureDialog, {
    doc: doc,
    onClose: function onClose() {
      return setMeasureDialog(false);
    }
  }) : null, manualDialog ? /*#__PURE__*/_react["default"].createElement(ManualDialog, {
    onClose: function onClose() {
      return setManualDialog(false);
    }
  }) : null, hasFocus ? /*#__PURE__*/_react["default"].createElement(_reactHotKeys["default"], {
    keyName: "h,shift+f,f,shift+v,v,z,a,w,t,shift+t,m,c",
    onKeyDown: onKeyDown
  }) : null);
}
function ToolBarIcon(_ref2) {
  var img = _ref2.img,
    title = _ref2.title,
    action = _ref2.action,
    _onClick = _ref2.onClick;
  var _useState5 = (0, _react.useState)(false),
    _useState6 = _slicedToArray(_useState5, 2),
    showTitle = _useState6[0],
    setShowTitle = _useState6[1];
  var onMouseOut = function onMouseOut() {
    setShowTitle(false);
  };
  var onMouseOver = function onMouseOver() {
    setShowTitle(true);
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _viewToolBarModule["default"].iconContainer
  }, /*#__PURE__*/_react["default"].createElement("img", {
    className: _viewToolBarModule["default"].iconImage,
    width: 28,
    height: 28,
    onMouseOut: onMouseOut,
    onMouseOver: onMouseOver,
    src: img,
    onClick: function onClick() {
      return _onClick(action);
    }
  }), showTitle ? /*#__PURE__*/_react["default"].createElement("div", {
    className: _viewToolBarModule["default"].iconTitle
  }, title) : null);
}
function MeasureDialog(_ref3) {
  var doc = _ref3.doc,
    onClose = _ref3.onClose;
  (0, _react.useEffect)(function () {
    doc.dispatch({
      type: _tuoDocument.types.START_PROCESS,
      payload: {
        type: 'analysis',
        config: {}
      }
    });
    return function () {
      doc.dispatch({
        type: _tuoDocument.types.QUIT_PROCESS
      });
    };
  }, []);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _viewToolBarModule["default"].measureContainer
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: '100px'
    }
  }, "\u6D4B\u91CF\u6A21\u5F0F"), /*#__PURE__*/_react["default"].createElement("button", {
    className: _viewToolBarModule["default"].closeButton,
    onClick: function onClick() {
      onClose();
    }
  }, "x"));
}
function ManualDialog(_ref4) {
  var onClose = _ref4.onClose;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _viewToolBarModule["default"].manualContainer
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      borderBottom: '1px solid #e0e0e0',
      padding: '4px'
    }
  }, /*#__PURE__*/_react["default"].createElement("button", {
    className: _viewToolBarModule["default"].closeButton,
    onClick: function onClick() {
      onClose();
    }
  }, "x")), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      padding: '4px'
    }
  }, /*#__PURE__*/_react["default"].createElement(_reactMarkdown["default"], {
    remarkPlugins: [_remarkGfm["default"]]
  }, _manual.manualText)));
}