import { useState, useEffect, useRef} from 'react'
function getStateByPath(doc, statePath) {
  if(!doc)
    return {}

  let state = doc.mainStore.getState()
  for (let k of statePath) {
    state = state[k]
  }
  return state
}

export function useDocumentState(doc, statePath) {
  const [docState, setDocState] = useState({})
  const unsubscribe = useRef(() => {})
  let listener = () => {
    if (doc.disposed)
      return
    let previousState = docState
    let currentState = getStateByPath(doc, statePath)
    currentState = getStateByPath(doc, statePath)

    // if(statePath[0] === 'raycast' && statePath[1] === 'selected')
    //   debugger


    if (currentState !== previousState) {
      setDocState(currentState)
    }
  }

  useEffect(() => {
    if(!doc)
      return
    let currentState = getStateByPath(doc, statePath)
    setDocState(currentState)
    unsubscribe.current()

    unsubscribe.current = doc.mainStore.subscribe(listener)
    return () => {
      unsubscribe.current()
    }
  }, [doc])
  return docState
}
