import React, { useRef, useEffect } from 'react'
import styles from './styles/view3d.module.css'

type View3DProps = {
  doc: any
}

function View3D<View3DProps>({ doc}){
  const viewRef = useRef<HTMLDivElement | null>(null)

  useEffect(() => {
    while (viewRef.current.firstChild) {
      viewRef.current.removeChild(viewRef.current.lastChild);
    }


    if(doc) {
      doc.setDom(viewRef.current)
      window.setTimeout(() => {
        window.dispatchEvent(new Event("resize"));
      }, 10);
    }
  }, [doc])

  return (
    <div className = {styles.container} style={{height: '100%', background: '#d7d8df'}} ref={viewRef} />
  )
}

export default View3D
